# -*- coding: utf-8 -*-
"""Experimental module for facilitated plotting of relaxed wavefunctions from .h5 output files."""

import argparse
import logging
from pathlib import Path

import h5py
import matplotlib.pyplot as plt
import numpy as np
from mpl_toolkits.axes_grid1 import AxesGrid


def provide_argparsing():
    """Provide an argument parser for the ITP plotting facility."""
    parser = argparse.ArgumentParser(
        prog="pyQD-wave",
        description=(
            "Used to plot optimised wavefunctions from ITP data "
            "found in .h5 files generated by pyQD. "
            "Currently only implemented for 2D wavefunctions."
        ),
    )
    parser.add_argument("file", help="The .h5-file generated by the pyQD program.")

    parser.add_argument(
        "-c",
        "--colormap",
        help="The colormap to be used for the contourf plot.",
        default="YlGnBu",
    )

    parser.add_argument(
        "-i",
        "--isometric",
        action="store_true",
        default=False,
        help=(
            "Whether to use a common color scale for all wavefunctions or "
            "normalize each function to it's respective maximum."
        ),
    )

    parser.add_argument(
        "-l",
        "--xylimits",
        type=tuple,
        default=(0, 0),
        help="x- & y-axis limits to use for the plotting",
    )
    return parser


def main():
    """Main function for the ITP wavefunction plotting module."""

    parser = provide_argparsing()
    args = parser.parse_args()

    h5filename = Path(args.file).resolve()

    h5file = h5py.File(h5filename, "r")
    datasets = h5file["wf"]

    xgrid = np.asarray(h5file["xgrid"])
    meshgrids = np.meshgrid(*[xgrid] * 2)

    sqr = int(np.floor(np.sqrt(len(datasets))))

    fig = plt.figure(figsize=(2 * sqr, 2 * sqr))

    grid = AxesGrid(
        fig,
        111,
        nrows_ncols=(sqr, sqr),
        axes_pad=0.05,
        cbar_mode=None,
        cbar_location="right",
        cbar_pad=0.1,
    )

    totalmax = np.nanmax(
        [np.nanmax(np.abs(np.asarray(ds).astype(np.complex128))) for ds in datasets]
    )

    xylims = (
        (np.nanmin(xgrid), np.nanmax(xgrid))
        if tuple(args.xylimits) == (0, 0)
        else args.xylimits
    )

    for idx, ax in enumerate(grid):
        try:
            _, dataset = list(datasets.items())[idx]
            ax = grid[idx]
            ax.set_axis_off()
            ax.set_ylim(xylims)
            ax.set_xlim(xylims)
            data = np.abs(np.asarray(dataset)[..., 0])
            ax.contourf(
                *meshgrids,
                data,
                30,
                vmin=0.0,
                vmax=np.nanmax(data) if not args.isometric else totalmax,
                cmap=args.colormap
            )
            ax.annotate(
                "{}: {:.2f} eV".format(
                    idx, float(dataset.attrs["total_energy"]) * 27.2118
                ),
                xy=(0.05, 0.9),
                xycoords="axes fraction",
                size="xx-small",
                color="gray",
            )
        except IndexError as e:
            logging.debug(e)

    fig.tight_layout()
    fname = h5filename.parent / (
        h5filename.stem + "_" + ("non-" if not args.isometric else "") + "isometric.png"
    )
    fig.savefig(fname)
